Scrollspy

Bootstrap 5 Scrollspy component

Automatically update Bootstrap navigation or list group components based on scroll position to indicate which link is currently active in the viewport.

Note: Read the API tab to find all available options and advanced customization

Required ES init: Scrollspy *
* UMD autoinits are enabled by default. This means that you don't need to initialize the component manually. However if you are using MDBootstrap ES format then you should pass the required components to the initMDB method.

Basic example

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
          <div class="row">
            <div class="col-md-8">
              <!-- Spied element -->
              <div
                data-mdb-scrollspy-init
                data-mdb-target="#scrollspy1"
                data-mdb-offset="0"
                class="scrollspy-example"
              >
                <section id="example-1">
                  <h3>Section 1</h3>
                  ...
                </section>
                <section id="example-2">
                  <h3>Section 2</h3>
                  ...
                </section>
                <section id="example-3">
                  <h3>Section 3</h3>
                  ...
                  <section id="example-sub-A">
                    <h3>Subsection A</h3>
                    ...
                  </section>
                  <section id="example-sub-B">
                    <h3>Subsection B</h3>
                    ...
                  </section>
                </section>
                <section id="example-4">
                  <h3>Section 4</h3>
                  ...
                </section>
              </div>
              <!-- Spied element -->
            </div>

            <div class="col-md-4">
              <!-- Scrollspy -->
              <div id="scrollspy1" class="sticky-top">
                <ul class="nav flex-column nav-pills menu-sidebar">
                  <li class="nav-item">
                    <a class="nav-link" href="#example-1">Section 1</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#example-2">Section 2</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#example-3">Section 3</a>
                    <ul class="nav flex-column ps-3">
                      <li class="nav-item">
                        <a class="nav-link" href="#example-sub-A">Subsection A</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-sub-B">Subsection B</a>
                      </li>
                    </ul>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#example-4">Section 4</a>
                  </li>
                </ul>
              </div>
              <!-- Scrollspy -->
            </div>
          </div>
        
        
    
        
            
          /* Styles required only for the example above */
          .scrollspy-example {
            position: relative;
            height: 200px;
            overflow: auto;
          }
        
        
    
        
            
          // Initialization for ES Users
          import { Scrollspy, initMDB } from "mdb-ui-kit";

          initMDB({ Scrollspy });
        
        
    

Collapsible

Hides all subsections of unactive section. To use it, simply add .collapsible-scrollspy class to the <a> element of section you want to set to be collapsible.

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
          <div class="row">
            <div class="col-md-8">
              <!-- Spied element -->
              <div
                data-mdb-scrollspy-init
                data-mdb-target="#scrollspy-collapsible"
                data-mdb-offset="0"
                class="scrollspy-example"
              >
                <section id="example-1-collapsible">
                  <h3>Section 1</h3>
                  ...
                </section>
                <section id="example-2-collapsible">
                  <h3>Section 2</h3>
                  ...
                </section>
                <section id="example-3-collapsible">
                  <h3>Section 3</h3>
                  ...
                  <section id="example-sub-A-collapsible">
                    <h3>Subsection A</h3>
                    ...
                  </section>
                  <section id="example-sub-B-collapsible">
                    <h3>Subsection B</h3>
                    ...
                  </section>
                </section>
                <section id="example-4-collapsible">
                  <h3>Section 4</h3>
                  ...
                </section>
              </div>
              <!-- Spied element -->
            </div>

            <div class="col-md-4">
              <!-- Scrollspy -->
              <div id="scrollspy-collapsible" class="sticky-top">
                <ul class="nav flex-column nav-pills menu-sidebar">
                  <li class="nav-item">
                    <a class="nav-link" href="#example-1-collapsible">Section 1</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#example-2-collapsible">Section 2</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link collapsible-scrollspy" href="#example-3-collapsible">Section 3</a>
                    <ul class="nav flex-column ps-3">
                      <li class="nav-item">
                        <a class="nav-link" href="#example-sub-A-collapsible">Subsection A</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-sub-B-collapsible">Subsection B</a>
                      </li>
                    </ul>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#example-4-collapsible">Section 4</a>
                  </li>
                </ul>
              </div>
              <!-- Scrollspy -->
            </div>
          </div>
        
        
    
        
            
          /* Styles required only for the example above */
          .scrollspy-example-collapsible {
            position: relative;
            height: 200px;
            overflow: auto;
          }
        
        
    
        
            
          // Initialization for ES Users
          import { Scrollspy, initMDB } from "mdb-ui-kit";

          initMDB({ Scrollspy });
        
        
    

How it works

Scrollspy has a few requirements to function properly:

  • It must be used on a Bootstrap nav component or list group.
  • Scrollspy requires position: relative; on the element you’re spying on, usually the <body>.
  • When spying on elements other than the <body>, be sure to have a height set and overflow-y: scroll; applied.
  • Anchors (<a>) are required and must point to an element with that id.

When successfully implemented, your nav or list group will update accordingly, moving the .active class from one item to the next based on their associated targets.


GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Scrollspy - API


Import

Importing components depends on how your application works. If you intend to use the MDBootstrap ES format, you must first import the component and then initialize it with the initMDB method. If you are going to use the UMD format, just import the mdb-ui-kit package.

        
            
          import { Scrollspy, initMDB } from "mdb-ui-kit";
  
          initMDB({ Scrollspy });
        
        
    
        
            
          import 'mdb-ui-kit';
        
        
    

Usage

Via data attributes

Using the Scrollspy component doesn't require any additional JavaScript code - simply add data-mdb-scrollspy-init attribute to the element you’re spying on (most typically this would be the <body>) and use other data attributes to set all options. For ES format, you must first import and call the initMDB method.

        
            
          <body data-mdb-scrollspy-init data-mdb-target="#navbar-example">
            ...
            <div id="navbar-example">
              <ul class="nav nav-tabs" role="tablist">
                ...
              </ul>
            </div>
            ...
          </body>
        
        
    
        
             body { position: relative; } 
        
    

Via JavaScript

After adding position: relative; in your CSS, call the scrollspy via JavaScript:

        
            
          const scrollSpy = new ScrollSpy(document.body, {
            target: '#navbar-example'
          })
        
        
    
        
            
          const scrollSpy = new mdb.ScrollSpy(document.body, {
            target: '#navbar-example'
          })
        
        
    

Resolvable ID targets required: Navbar links must have resolvable id targets. For example, a <a href="#home">home</a> must correspond to something in the DOM like <div id="home"></div>.

Non-visible target elements ignored: Target elements that are not visible will be ignored and their corresponding nav items will never be highlighted.

Via jQuery

Note: By default, MDB does not include jQuery and you have to add it to the project on your own.

        
            
          $(document).ready(() => {
            $('.example-class').scrollSpy(options);
          });
        
        
    

Options

Options can be passed via data attributes or JavaScript. For data attributes, append the option name to data-mdb-, as in data-mdb-offset="".

Name Type Default Description
offset number | null null Pixels to offset from top when calculating position of scroll.
rootMargin string '0px 0px -25%' Intersection Observer rootMargin valid units, when calculating scroll position.
smoothScroll boolean false Enables smooth scrolling when a user clicks on a link that refers to ScrollSpy observables.
target string | DOM element null Specifies element to apply Scrollspy plugin.
threshold array [0.1, 0.5, 1] IntersectionObserver threshold valid input, when calculating scroll position.

Methods

Name Description Example
refresh When using scrollspy in conjunction with adding or removing of elements from the DOM, you’ll need to call the refresh method instance.refresh()
dispose Destroys an element’s tab. instance.dispose()
getInstance Static method which allows you to get the scrollspy instance associated to a DOM element. ScrollSpy.getInstance(dataSpyEl)
        
            
          const dataSpyList = document.querySelectorAll('[data-mdb-scrollspy-init]')
          dataSpyList.forEach((dataSpyEl) => {
            ScrollSpy.getInstance(dataSpyEl).refresh()
          })
        
        
    
        
            
        const dataSpyList = document.querySelectorAll('[data-mdb-scrollspy-init]')
        dataSpyList.forEach((dataSpyEl) => {
          mdb.ScrollSpy.getInstance(dataSpyEl).refresh()
        })
      
        
    

Events

Event type Description
activate.mdb.scrollspy This event fires on the scroll element whenever a new item becomes activated by the scrollspy.
        
            
        const firstScrollSpyEl = document.querySelector('[data-mdb-scrollspy-init]')
        firstScrollSpyEl.addEventListener('activate.mdb.scrollspy', () => {
          // do something...
        })
        
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, scrollspy now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Scrollspy CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .nav-pills
        // &.menu-sidebar
        --#{$prefix}scrollspy-menu-sidebar-font-size: #{$scrollspy-menu-sidebar-font-size};
        --#{$prefix}scrollspy-menu-sidebar-color: #{$scrollspy-menu-sidebar-color};
        --#{$prefix}scrollspy-menu-sidebar-line-height: #{$scrollspy-menu-sidebar-line-height};
        --#{$prefix}scrollspy-menu-sidebar-padding-x: #{$scrollspy-menu-sidebar-padding-x};
        --#{$prefix}scrollspy-menu-sidebar-font-weight: #{$scrollspy-menu-sidebar-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-transition: #{$scrollspy-menu-sidebar-transition};
        --#{$prefix}scrollspy-menu-sidebar-margin-y: #{$scrollspy-menu-sidebar-margin-y};
  
        // .nav-link.active,
        // .show > .nav-link
        --#{$prefix}scrollspy-menu-sidebar-active-color: #{$scrollspy-menu-sidebar-active-color};
        --#{$prefix}scrollspy-menu-sidebar-active-font-weight: #{$scrollspy-menu-sidebar-active-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-active-border-width: #{$scrollspy-menu-sidebar-active-border-width};
        --#{$prefix}scrollspy-menu-sidebar-active-border-color: #{$scrollspy-menu-sidebar-active-border-color};
  
        // .collapsible-scrollspy ~ .nav
        --#{$prefix}scrollspy-collapsible-nav-transition-time: #{$scrollspy-collapsible-nav-transition-time};
        
        
    

SCSS variables

        
            
        $scrollspy-menu-sidebar-font-size: 0.8rem;
        $scrollspy-menu-sidebar-color: var(--#{$prefix}body-color);
        $scrollspy-menu-sidebar-line-height: 1.1rem;
        $scrollspy-menu-sidebar-padding-x: 5px;
        $scrollspy-menu-sidebar-font-weight: 400;
        $scrollspy-menu-sidebar-transition: all 0.2s ease-in-out;
        $scrollspy-menu-sidebar-margin-y: 3px;

        $scrollspy-menu-sidebar-active-color: $primary;
        $scrollspy-menu-sidebar-active-font-weight: 600;
        $scrollspy-menu-sidebar-active-border-width: 0.125rem;
        $scrollspy-menu-sidebar-active-border-color: $primary;

        $scrollspy-collapsible-nav-transition-time: 0.5s;

Scrollspy

React Bootstrap 5 Scrollspy component

Automatically update Bootstrap navigation or list group components based on scroll position to indicate which link is currently active in the viewport.

Note: Read the API tab to find all available options and advanced customization


Basic example

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
          import React, { useRef } from 'react';
          import { MDBCol, MDBContainer, MDBRow, MDBScrollspy, MDBScrollspyLink, MDBScrollspySubList } from 'mdb-react-ui-kit';
                   
          export default function App() {
            const section1 = useRef(null);
            const section2 = useRef(null);
            const section3 = useRef(null);
            const section4 = useRef(null);
            const sectionA = useRef(null);
            const sectionB = useRef(null);

            const containerRef = useRef(null);

            const subsections = [sectionA, sectionB];

            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol md='8'>
                    <div id='element' ref={containerRef} className='scrollspy-example'>
                      <section ref={section1} id='section-1'>
                        <h3>Section 1</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                      </section>
                      <section ref={section2} id='section-2'>
                        <h3>Section 2</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                      </section>
                      <section ref={section3} id='section-3'>
                        <h3>Section 3</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                        <section ref={sectionA} id='subsection-a'>
                          <h3>Subsection A</h3>
                          <p>
                            Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                            maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                            quaerat accusamus numquam.
                          </p>
                          <p>
                            Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                            maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                            quaerat accusamus numquam.
                          </p>
                        </section>
                        <section ref={sectionB} id='subsection-b'>
                          <h3>Subsection B</h3>
                          <p>
                            Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                            maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                            quaerat accusamus numquam.
                          </p>
                          <p>
                            Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                            maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                            quaerat accusamus numquam.
                          </p>
                        </section>
                      </section>
                      <section ref={section4} id='section-4'>
                        <h3>Section 4</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                          maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                          quaerat accusamus numquam.
                        </p>
                      </section>
                    </div>
                  </MDBCol>
      
                  <MDBCol md='4'>
                    <MDBScrollspy container={containerRef}>
                      <MDBScrollspyLink targetRef={section1}>Section 1</MDBScrollspyLink>
                      <MDBScrollspyLink targetRef={section2}>Section 2</MDBScrollspyLink>
                      <MDBScrollspyLink subsections={subsections} targetRef={section3}>
                        Section 3
                      </MDBScrollspyLink>
                      <MDBScrollspySubList className='ps-3'>
                        <MDBScrollspyLink targetRef={sectionA}>Subsection A</MDBScrollspyLink>
                        <MDBScrollspyLink targetRef={sectionB}>Subsection B</MDBScrollspyLink>
                      </MDBScrollspySubList>
                      <MDBScrollspyLink targetRef={section4}>Section 4</MDBScrollspyLink>
                    </MDBScrollspy>
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }
          
        
    
        
            
            /* Styles required only for the example above */
            .scrollspy-example {
              position: relative;
              height: 200px;
              overflow: auto;
            }
          
        
    

Collapsible

Hides all subsections of unactive section. To use it, simply add collapsible property to the MDBScrollspyLink and MDBScrollspySubList.

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
              import React, { useRef } from 'react';
              import { MDBCol, MDBContainer, MDBRow, MDBScrollspy, MDBScrollspyLink, MDBScrollspySubList } from 'mdb-react-ui-kit';
                       
              export default function App() {
                const collapseSection1 = useRef(null);
                const collapseSection2 = useRef(null);
                const collapseSection3 = useRef(null);
                const collapseSection4 = useRef(null);
                const collapseSectionA = useRef(null);
                const collapseSectionB = useRef(null);

                const collapseContainerRef = useRef(null);

                const collapseSubsections = [collapseSectionA, collapseSectionB];

                return (
                  <MDBContainer>
                    <MDBRow>
                      <MDBCol md='8'>
                        <div id='collapse' ref={collapseContainerRef} className='scrollspy-example'>
                          <section ref={collapseSection1} id='section-collapse-1'>
                            <h3>Section 1</h3>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                          </section>
                          <section ref={collapseSection2} id='section-collapse-2'>
                            <h3>Section 2</h3>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                          </section>
                          <section ref={collapseSection3} id='section-collapse-3'>
                            <h3>Section 3</h3>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                            <section ref={collapseSectionA} id='subsection-collapse-a'>
                              <h3>Subsection A</h3>
                              <p>
                                Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                                maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                                quaerat accusamus numquam.
                              </p>
                              <p>
                                Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                                maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                                quaerat accusamus numquam.
                              </p>
                            </section>
                            <section ref={collapseSectionB} id='subsection-collapse-b'>
                              <h3>Subsection B</h3>
                              <p>
                                Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                                maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                                quaerat accusamus numquam.
                              </p>
                              <p>
                                Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                                maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                                quaerat accusamus numquam.
                              </p>
                            </section>
                          </section>
                          <section ref={collapseSection4} id='section-collapse-4'>
                            <h3>Section 4</h3>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                            <p>
                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error
                              maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis
                              quaerat accusamus numquam.
                            </p>
                          </section>
                        </div>
                      </MDBCol>
          
                      <MDBCol md='4'>
                        <MDBScrollspy container={collapseContainerRef}>
                          <MDBScrollspyLink targetRef={collapseSection1}>Section 1</MDBScrollspyLink>
                          <MDBScrollspyLink targetRef={collapseSection2}>Section 2</MDBScrollspyLink>
                          <MDBScrollspyLink collapsible subsections={collapseSubsections} targetRef={collapseSection3}>
                            Section 3
                          </MDBScrollspyLink>
                          <MDBScrollspySubList className='ps-3' collapsible={collapseSubsections}>
                            <MDBScrollspyLink targetRef={collapseSectionA}>Subsection A</MDBScrollspyLink>
                            <MDBScrollspyLink targetRef={collapseSectionB}>Subsection B</MDBScrollspyLink>
                          </MDBScrollspySubList>
                          <MDBScrollspyLink targetRef={collapseSection4}>Section 4</MDBScrollspyLink>
                        </MDBScrollspy>
                      </MDBCol>
                    </MDBRow>>
                  </MDBContainer>
                );
              }
              
        
    
        
            
                /* Styles required only for the example above */
                .scrollspy-example {
                  position: relative;
                  height: 200px;
                  overflow: auto;
                }
              
        
    

How it works

Scrollspy has a few requirements to function properly:

  • Scrollspy requires position: relative; on the element you’re spying on, usually the <body>.
  • When spying on elements other than the <body>, be sure to have a height set and overflow-y: scroll; applied.
  • <MDBScrollspyLink> are required and must point to an previously selected scrollElement and contain active prop.

When successfully implemented, your nav or list group will update accordingly, moving the .active class from one item to the next based on their associated targets.


TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Scrollspy - API


Import

        
            
          import { 
            MDBScrollspy,
            MDBScrollspyLink,
            MDBScrollspySubList
          } from 'mdb-react-ui-kit';
        
        
    

Properties

MDBScrollspy

Name Type Default Description Example
container React.MutableRefObject<any> Window Specifies element to apply MDBScrollspy. <MDBScrollspy container={containerRef} />
offset number 10 Pixels to offset from top when calculating position of scroll. <MDBScrollspy offset={40} />

MDBScrollspySubList

Name Type Default Description Example
collapsible boolean false Enables collapsible mode. <MDBScrollspySubList collapsible />

Events


CSS variables

As part of MDB’s evolving CSS variables approach, scrollspy now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Scrollspy CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .nav-pills
        // &.menu-sidebar
        --#{$prefix}scrollspy-menu-sidebar-font-size: #{$scrollspy-menu-sidebar-font-size};
        --#{$prefix}scrollspy-menu-sidebar-color: #{$scrollspy-menu-sidebar-color};
        --#{$prefix}scrollspy-menu-sidebar-line-height: #{$scrollspy-menu-sidebar-line-height};
        --#{$prefix}scrollspy-menu-sidebar-padding-x: #{$scrollspy-menu-sidebar-padding-x};
        --#{$prefix}scrollspy-menu-sidebar-font-weight: #{$scrollspy-menu-sidebar-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-transition: #{$scrollspy-menu-sidebar-transition};
        --#{$prefix}scrollspy-menu-sidebar-margin-y: #{$scrollspy-menu-sidebar-margin-y};
  
        // .nav-link.active,
        // .show > .nav-link
        --#{$prefix}scrollspy-menu-sidebar-active-color: #{$scrollspy-menu-sidebar-active-color};
        --#{$prefix}scrollspy-menu-sidebar-active-font-weight: #{$scrollspy-menu-sidebar-active-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-active-border-width: #{$scrollspy-menu-sidebar-active-border-width};
        --#{$prefix}scrollspy-menu-sidebar-active-border-color: #{$scrollspy-menu-sidebar-active-border-color};
  
        // .collapsible-scrollspy ~ .nav
        --#{$prefix}scrollspy-collapsible-nav-transition-time: #{$scrollspy-collapsible-nav-transition-time};
        
        
    

SCSS variables

        
            
        $scrollspy-menu-sidebar-font-size: 0.8rem;
        $scrollspy-menu-sidebar-color: #262626;
        $scrollspy-menu-sidebar-line-height: 1.1rem;
        $scrollspy-menu-sidebar-padding-x: 5px;
        $scrollspy-menu-sidebar-font-weight: 400;
        $scrollspy-menu-sidebar-transition: all 0.2s ease-in-out;
        $scrollspy-menu-sidebar-margin-y: 3px;

        $scrollspy-menu-sidebar-active-color: $primary;
        $scrollspy-menu-sidebar-active-font-weight: 600;
        $scrollspy-menu-sidebar-active-border-width: 0.125rem;
        $scrollspy-menu-sidebar-active-border-color: $primary;

        $scrollspy-collapsible-nav-transition-time: 0.5s;

Scrollspy

Vue Bootstrap 5 Scrollspy

Automatically update Bootstrap navigation or list group components based on scroll position to indicate which link is currently active in the viewport.

Note: Read the API tab to find all available options and advanced customization


Basic example

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
            <template>
              <MDBRow>
                <MDBCol md="8">
                  <div id="scrollspy" class="scrollspy-example">
                    <section id="example-1">
                      <h3>Section 1</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section id="example-2">
                      <h3>Section 2</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section id="example-3">
                      <h3>Section 3</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <section id="example-sub-A">
                        <h3>Subsection A</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                      </section>
                      <section id="example-sub-B">
                        <h3>Subsection B</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                      </section>
                    </section>
                    <section id="example-4">
                      <h3>Section 4</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                  </div>
                </MDBCol>
                <MDBCol md="4">
                  <div class="sticky-top">
                    <ul class="nav flex-column nav-pills menu-sidebar" v-mdb-scrollspy="{ container: 'scrollspy' }">
                      <li class="nav-item">
                        <a class="nav-link" href="#example-1">Section 1</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-2">Section 2</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-3">Section 3</a>
                        <ul class="nav flex-column ps-3">
                          <li class="nav-item">
                            <a class="nav-link" href="#example-sub-A">Subsection A</a>
                          </li>
                          <li class="nav-item">
                            <a class="nav-link" href="#example-sub-B">Subsection B</a>
                          </li>
                        </ul>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-4">Section 4</a>
                      </li>
                    </ul>
                  </div>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { mdbScrollspy, MDBRow, MDBCol } from "mdb-vue-ui-kit";

              export default {
                components: {
                  MDBRow,
                  MDBCol
                },
                directives: {
                  mdbScrollspy
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { mdbScrollspy as vMdbScrollspy, MDBRow, MDBCol } from "mdb-vue-ui-kit";
            </script>
          
        
    
        
            
            <style>
              /* Styles required only for the example above */
              .scrollspy-example {
                position: relative;
                height: 200px;
                overflow: auto;
              }
            </style>
          
        
    

Collapsible

Hides all subsections of unactive section. To use it, simply add .collapsible-scrollspy class to the <a> element of section you want to set to be collapsible.

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
            <template>
              <MDBRow>
                <MDBCol md="8">
                  <div id="scrollspy-collapsible" class="scrollspy-example-collapsible">
                    <section id="example-1-collapsible">
                      <h3>Section 1</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section id="example-2-collapsible">
                      <h3>Section 2</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section id="example-3-collapsible">
                      <h3>Section 3</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <section id="example-sub-A-collapsible">
                        <h3>Subsection A</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                      </section>
                      <section id="example-sub-B-collapsible">
                        <h3>Subsection B</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing
                          elit. Labore earum natus vel minima quod error maxime,
                          molestias ut. Fuga dignissimos nisi nemo necessitatibus
                          quisquam obcaecati et reiciendis quaerat accusamus
                          numquam.
                        </p>
                      </section>
                    </section>
                    <section id="example-4-collapsible">
                      <h3>Section 4</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Labore earum natus vel minima quod error maxime, molestias
                        ut. Fuga dignissimos nisi nemo necessitatibus quisquam
                        obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                  </div>
                </MDBCol>
                <MDBCol md="4">
                  <div class="sticky-top">
                    <ul class="nav flex-column nav-pills menu-sidebar" v-mdb-scrollspy="{ container: 'scrollspy-collapsible' }">
                      <li class="nav-item">
                        <a class="nav-link" href="#example-1-collapsible">Section 1</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-2-collapsible">Section 2</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link collapsible-scrollspy" href="#example-3-collapsible">Section 3</a>
                        <ul class="nav flex-column ps-3">
                          <li class="nav-item">
                            <a class="nav-link " href="#example-sub-A-collapsible">Subsection A</a>
                          </li>
                          <li class="nav-item">
                            <a class="nav-link" href="#example-sub-B-collapsible">Subsection B</a>
                          </li>
                        </ul>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="#example-4-collapsible">Section 4</a>
                      </li>
                    </ul>
                  </div>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { mdbScrollspy, MDBRow, MDBCol } from "mdb-vue-ui-kit";

              export default {
                components: {
                  MDBRow,
                  MDBCol
                },
                directives: {
                  mdbScrollspy
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { mdbScrollspy as vMdbScrollspy, MDBRow, MDBCol } from "mdb-vue-ui-kit";
            </script>
          
        
    
        
            
            <style>
              /* Styles required only for the example above */
              .scrollspy-example-collapsible {
                position: relative;
                height: 200px;
                overflow: auto;
              }
            </style>
          
        
    

How it works

Scrollspy has a few requirements to function properly:

  • It must be used on a Bootstrap nav component or list group.
  • Scrollspy requires position: relative; on the element you’re spying on, usually the <body>.
  • When spying on elements other than the <body>, be sure to have a height set and overflow-y: scroll; applied.
  • Anchors (<a>) are required and must point to an element with that id.

When successfully implemented, your nav or list group will update accordingly, moving the .active class from one item to the next based on their associated targets.


GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Scrollspy - API


Import

        
            
          <script>
            import {
              mdbScrollspy
            } from 'mdb-vue-ui-kit';
          </script>
        
        
    

Properties

Property Type Default Description
async Boolean false Enables recalculating the directive's data based on loading value.
callback String Name of the method which will be called with the active link's index once it changes.
container [String, Object] window The directive selects the element with the given ID as the reference container. By default its value is set to window.
loading Boolean false Option available with the async modifier - chnaging its value from true to false will trigger recalculating scrollspy.
offset Number 0 Sets an offset from top when calculating position of the scroll.

CSS variables

As part of MDB’s evolving CSS variables approach, scrollspy now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Scrollspy CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .nav-pills
        // &.menu-sidebar
        --#{$prefix}scrollspy-menu-sidebar-font-size: #{$scrollspy-menu-sidebar-font-size};
        --#{$prefix}scrollspy-menu-sidebar-color: #{$scrollspy-menu-sidebar-color};
        --#{$prefix}scrollspy-menu-sidebar-line-height: #{$scrollspy-menu-sidebar-line-height};
        --#{$prefix}scrollspy-menu-sidebar-padding-x: #{$scrollspy-menu-sidebar-padding-x};
        --#{$prefix}scrollspy-menu-sidebar-font-weight: #{$scrollspy-menu-sidebar-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-transition: #{$scrollspy-menu-sidebar-transition};
        --#{$prefix}scrollspy-menu-sidebar-margin-y: #{$scrollspy-menu-sidebar-margin-y};
  
        // .nav-link.active,
        // .show > .nav-link
        --#{$prefix}scrollspy-menu-sidebar-active-color: #{$scrollspy-menu-sidebar-active-color};
        --#{$prefix}scrollspy-menu-sidebar-active-font-weight: #{$scrollspy-menu-sidebar-active-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-active-border-width: #{$scrollspy-menu-sidebar-active-border-width};
        --#{$prefix}scrollspy-menu-sidebar-active-border-color: #{$scrollspy-menu-sidebar-active-border-color};
  
        // .collapsible-scrollspy ~ .nav
        --#{$prefix}scrollspy-collapsible-nav-transition-time: #{$scrollspy-collapsible-nav-transition-time};
        
        
    

SCSS variables

        
            
        $scrollspy-menu-sidebar-font-size: 0.8rem;
        $scrollspy-menu-sidebar-color: var(--#{$prefix}body-color);
        $scrollspy-menu-sidebar-line-height: 1.1rem;
        $scrollspy-menu-sidebar-padding-x: 5px;
        $scrollspy-menu-sidebar-font-weight: 400;
        $scrollspy-menu-sidebar-transition: all 0.2s ease-in-out;
        $scrollspy-menu-sidebar-margin-y: 3px;

        $scrollspy-menu-sidebar-active-color: $primary;
        $scrollspy-menu-sidebar-active-font-weight: 600;
        $scrollspy-menu-sidebar-active-border-width: 0.125rem;
        $scrollspy-menu-sidebar-active-border-color: $primary;

        $scrollspy-collapsible-nav-transition-time: 0.5s;

Scrollspy

Angular Bootstrap 5 Scrollspy component

Automatically update Bootstrap navigation or list group components based on scroll position to indicate which link is currently active in the viewport.

Note: Read the API tab to find all available options and advanced customization


Basic example

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
            <div class="row">
              <div class="col-md-8">
                <div class="scrollspy-example scrollspy-container">
                  <section mdbScrollspyElement="scrollspy" id="example-1">
                    <h3>Section 1</h3>
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                      minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                      necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                    </p>
                  </section>
                  <section mdbScrollspyElement="scrollspy" id="example-2">
                    <h3>Section 2</h3>
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                      minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                      necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                    </p>
                  </section>
                  <section mdbScrollspyElement="scrollspy" id="example-3">
                    <h3>Section 3</h3>
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                      minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                      necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                    </p>
                    <section mdbScrollspyElement="scrollspy-2" id="example-5">
                      <h3>Subsection A</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus
                        vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section mdbScrollspyElement="scrollspy-2" id="example-6">
                      <h3>Subsection B</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus
                        vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                  </section>
                  <section mdbScrollspyElement="scrollspy" id="example-4">
                    <h3>Section 4</h3>
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                      minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                      necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                    </p>
                  </section>
                </div>
              </div>

              <div class="col-md-4">
                <div id="scrollspy" class="sticky-top">
                  <ul mdbScrollspy="scrollspy" class="nav flex-column nav-pills menu-sidebar">
                    <li class="nav-item">
                      <a mdbScrollspyLink="example-1" class="nav-link">Section 1</a>
                    </li>
                    <li class="nav-item">
                      <a mdbScrollspyLink="example-2" class="nav-link">Section 2</a>
                    </li>
                    <li class="nav-item">
                      <a mdbScrollspyLink="example-3" class="nav-link">Section 3</a>
                      <ul mdbScrollspy="scrollspy-2" class="nav flex-column ps-3">
                        <li class="nav-item">
                          <a mdbScrollspyLink="example-5" class="nav-link">Subsection A</a>
                        </li>
                        <li class="nav-item">
                          <a mdbScrollspyLink="example-6" class="nav-link">Subsection B</a>
                        </li>
                      </ul>
                    </li>
                    <li class="nav-item">
                      <a mdbScrollspyLink="example-4" class="nav-link">Section 4</a>
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          
        
    
        
            
            .scrollspy-example {
              position: relative;
              height: 200px;
              overflow: auto;
            }
          
        
    

Collapsible

Hides all subsections of unactive section. To use it, simply add [collapsible]="true" input to the ul element with mdbScrollspy directive of section you want to to be collapsible.

Section 1

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 2

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 3

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection A

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Subsection B

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Section 4

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.

        
            
              <div class="row">
                <div class="col-md-8">
                  <div class="scrollspy-example scrollspy-container">
                    <section mdbScrollspyElement="scrollspy" id="example-1">
                      <h3>Section 1</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                        minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section mdbScrollspyElement="scrollspy" id="example-2">
                      <h3>Section 2</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                        minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                    <section mdbScrollspyElement="scrollspy" id="example-3">
                      <h3>Section 3</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                        minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                      <section mdbScrollspyElement="scrollspy-2" id="example-5">
                        <h3>Subsection A</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus
                          vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                          necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                        </p>
                      </section>
                      <section mdbScrollspyElement="scrollspy-2" id="example-6">
                        <h3>Subsection B</h3>
                        <p>
                          Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus
                          vel minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                          necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                        </p>
                      </section>
                    </section>
                    <section mdbScrollspyElement="scrollspy" id="example-4">
                      <h3>Section 4</h3>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Labore earum natus vel
                        minima quod error maxime, molestias ut. Fuga dignissimos nisi nemo
                        necessitatibus quisquam obcaecati et reiciendis quaerat accusamus numquam.
                      </p>
                    </section>
                  </div>
                </div>
  
                <div class="col-md-4">
                  <div id="scrollspy" class="sticky-top">
                    <ul mdbScrollspy="scrollspy" class="nav flex-column nav-pills menu-sidebar">
                      <li class="nav-item">
                        <a mdbScrollspyLink="example-1" class="nav-link">Section 1</a>
                      </li>
                      <li class="nav-item">
                        <a mdbScrollspyLink="example-2" class="nav-link">Section 2</a>
                      </li>
                      <li class="nav-item">
                        <a mdbScrollspyLink="example-3" class="nav-link">Section 3</a>
                        <ul mdbScrollspy="scrollspy-2" class="nav flex-column ps-3" [collapsible]="true">
                          <li class="nav-item">
                            <a mdbScrollspyLink="example-5" class="nav-link">Subsection A</a>
                          </li>
                          <li class="nav-item">
                            <a mdbScrollspyLink="example-6" class="nav-link">Subsection B</a>
                          </li>
                        </ul>
                      </li>
                      <li class="nav-item">
                        <a mdbScrollspyLink="example-4" class="nav-link">Section 4</a>
                      </li>
                    </ul>
                  </div>
                </div>
              </div>
            
        
    
        
            
              .scrollspy-example {
                position: relative;
                height: 200px;
                overflow: auto;
              }
            
        
    

GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Scrollspy - API


Import

        
            
          import { MdbScrollspyModule } from 'mdb-angular-ui-kit/scrollspy';
          …
          @NgModule ({
            ...
            imports: [MdbScrollspyModule],
            ...
          })
        
        
    

Inputs

MdbScrollspy

Name Type Default Description
collapsible boolean false Makes section collapsible

MdbScrollspyElement / MdbScrollspyWindow

Name Type Default Description
offset number 10 Pixels to offset from top when calculating position of scroll.

MdbScrollspyLink

Name Type Default Description
scrollIntoView boolean false Scroll to the section assigned to a given link.

Outputs

MdbScrollspyDirective

Name Type Description
activeLinkChange EventEmitter<any> This event fires on the scroll element whenever a new item becomes activated by the scrollspy.
        
            
              <ul mdbScrollspy="scrollspy" (activeLinkChange)="onActiveLinkChange($event)" class="nav flex-column nav-pills menu-sidebar">
                ...
              </ul>
            
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'app-root',
            templateUrl: './app.component.html',
            styleUrls: ['./app.component.scss'],
          })
          export class AppComponent {
            onActiveLinkChange(link: any): void {
              console.log('active link', link);
            }
          }          
          
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, scrollspy now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Scrollspy CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .nav-pills
        // &.menu-sidebar
        --#{$prefix}scrollspy-menu-sidebar-font-size: #{$scrollspy-menu-sidebar-font-size};
        --#{$prefix}scrollspy-menu-sidebar-color: #{$scrollspy-menu-sidebar-color};
        --#{$prefix}scrollspy-menu-sidebar-line-height: #{$scrollspy-menu-sidebar-line-height};
        --#{$prefix}scrollspy-menu-sidebar-padding-x: #{$scrollspy-menu-sidebar-padding-x};
        --#{$prefix}scrollspy-menu-sidebar-font-weight: #{$scrollspy-menu-sidebar-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-transition: #{$scrollspy-menu-sidebar-transition};
        --#{$prefix}scrollspy-menu-sidebar-margin-y: #{$scrollspy-menu-sidebar-margin-y};
  
        // .nav-link.active,
        // .show > .nav-link
        --#{$prefix}scrollspy-menu-sidebar-active-color: #{$scrollspy-menu-sidebar-active-color};
        --#{$prefix}scrollspy-menu-sidebar-active-font-weight: #{$scrollspy-menu-sidebar-active-font-weight};
        --#{$prefix}scrollspy-menu-sidebar-active-border-width: #{$scrollspy-menu-sidebar-active-border-width};
        --#{$prefix}scrollspy-menu-sidebar-active-border-color: #{$scrollspy-menu-sidebar-active-border-color};
  
        // .collapsible-scrollspy ~ .nav
        --#{$prefix}scrollspy-collapsible-nav-transition-time: #{$scrollspy-collapsible-nav-transition-time};
        
        
    

SCSS variables

        
            
        $scrollspy-menu-sidebar-font-size: 0.8rem;
        $scrollspy-menu-sidebar-color: #262626;
        $scrollspy-menu-sidebar-line-height: 1.1rem;
        $scrollspy-menu-sidebar-padding-x: 5px;
        $scrollspy-menu-sidebar-font-weight: 400;
        $scrollspy-menu-sidebar-transition: all 0.2s ease-in-out;
        $scrollspy-menu-sidebar-margin-y: 3px;

        $scrollspy-menu-sidebar-active-color: $primary;
        $scrollspy-menu-sidebar-active-font-weight: 600;
        $scrollspy-menu-sidebar-active-border-width: 0.125rem;
        $scrollspy-menu-sidebar-active-border-color: $primary;

        $scrollspy-collapsible-nav-transition-time: 0.5s;